<template>
    <div>
        <v-dialog v-model="showDialog" persistent max-width="600px">
            <v-card>
                <v-card-title style="background-color:black;">
                    <h1 style="color:white;" class="langTitles">
                        {{ language.id ? 'EDITAR LENGUAJE' : 'CREAR LENGUAJE' }}
                    </h1>
                </v-card-title>
                <v-card-text>
                    <v-container>
                        <v-form v-model="isValidForm" lazy-validation ref="form">
                            <v-row>
                                <v-col cols="12">
                                    <span style="font-size: 12px;">Nombre del lenguaje (Pantalla de Inicio)</span>
                                    <v-text-field
                                        v-model="auxLanguage.name"
                                        class="langNam"
                                        required
                                        :rules="languageNameRules"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <span>Moneda</span>
                                    <v-text-field
                                        number
                                        :rules="currencyRules"
                                        v-model="auxLanguage.currency"
                                        class="tfcurrency"
                                        @change="currencyChangeWarning"
                                    ></v-text-field>
                                </v-col>
                                <v-col>
                                    <span>Tipo de cambio</span>
                                    <v-text-field
                                        type="number"
                                        :value="Number(auxLanguage.change)"
                                        @input="input => (auxLanguage.change = Number(input))"
                                        :rules="[
                                            v => v > 0 || 'El tipo de cambio es requerido y no puede ser negativo'
                                        ]"
                                        class="tfcurrency"
                                        suffix="Pesos mexicanos"
                                        prefix="$"
                                        hint="¿A cuántos pesos mexicanos equivale?"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <span>Seleccionar Lenguaje</span>
                                    <v-select
                                        :items="langInternationalizations"
                                        :value="language ? language.language : ''"
                                        @input="lan => (auxLanguage.language = lan)"
                                        :rules="langRules"
                                        class="cpick2"
                                    ></v-select>
                                </v-col>
                                <v-col>
                                    <span class="dtitles">Prioridad de aparición en catálogo</span>
                                    <v-text-field
                                        type="number"
                                        v-model="auxLanguage.order"
                                        :rules="priorityRules"
                                        class="dtitle1"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <span>Icono del lenguaje</span>
                                    <drag-and-drop
                                        max="7"
                                        resetOffset="5"
                                        :uri="language.icon"
                                        :files="filesDish"
                                        @filesChanged="addDropFile"
                                        v-model="language.icon"
                                    >
                                        {{ fileIconLang.name || 'Arrastra para cargar un archivo!' }}
                                    </drag-and-drop>
                                </v-col>
                            </v-row>
                        </v-form>
                    </v-container>
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="yellow darken-1" @click="closeWindow" class="btnwidth">CERRAR</v-btn>
                    <v-btn
                        color="yellow darken-1"
                        @click="saveLanguage($event, auxLanguage)"
                        class="btnwidth"
                        :disabled="!isValidForm"
                        >GUARDAR</v-btn
                    >
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { LangMenu } from '@/model/menu/LangMenu';
import { newTimestamp } from '@/config/serializables';
import { isAlpha, isNumericText } from '@/StringUtils';
import DragAndDrop from '@/components/commons/DragAndDrop.vue';

@Component({
    components: { DragAndDrop }
})
export default class Language extends Vue {
    @Prop({ default: () => new LangMenu('', '', '', '', '', -1, newTimestamp(), 0) })
    language!: LangMenu;
    @Prop({ default: false })
    showDialog!: boolean;
    @Prop({ default: '' })
    menuId!: string;
    langInternationalizations = ['spanish', 'english', 'italian'];
    auxLanguage = new LangMenu('', '', '', '', '', 0, newTimestamp(), 0);

    fileIconLang = new File([], '');
    isValidForm = true;

    languageNameRules = [
        (v: string) => !!v || 'Nombre de lenguaje es requerido',
        (v: string) => (v && v.length > 1) || 'Nombre debe tener al menos 2 caracteres',
        (v: string) => isAlpha(v) || 'Nombre no debe contener caracteres especiales'
    ];

    currencyRules = [
        (v: string) => !!v || 'Tipo de cambio es requerido',
        (v: string) => (v && v.length > 1) || 'Moneda debe tener por lo menos 2 caracteres',
        (v: string) => isAlpha(v) || 'Moneda no debe contener caracteres especiales'
    ];
    priorityRules = [
        (v: string) => !!v || 'Orden de aparicion es requerido',
        (v: string) => isNumericText(v) || 'Orden de aparicion debe ser un numero mayor a cero'
    ];

    langRules = [(v: string) => this.langInternationalizations.includes(v) || 'Lenguaje invalido'];

    currencyChangeWarning() {
        this.$emit('currencyChange');
    }

    async closeWindow() {
        this.$emit('setShowLangModal', false);
        this.auxLanguage = Object.assign(this.auxLanguage, this.language);
    }

    async addDropFile(fileList: File[]) {
        if (fileList) {
            this.fileIconLang = fileList[0];
        }
    }
    saveLanguage(event: Event, language?: LangMenu) {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            this.$emit('saveLanguage', language, this.fileIconLang);
            this.$emit('setShowLangModal', false);
        }
    }

    @Watch('language')
    async onLanguageChange(newLang: LangMenu | null) {
        this.fileIconLang = new File([], newLang?.icon || '');
        this.auxLanguage = Object.assign(this.auxLanguage, this.language);
    }
    get filesDish() {
        return this.language.icon;
    }
}
</script>

<style type="text/css">
@media (max-width: 700px) {
    .langNam {
        margin-top: 15px;
    }
    .langTitles {
        margin-top: 15px;
        font-size: 30px;
    }
    .btnwidth {
        position: relative;
        width: 150px;
    }
    .tfcurrency {
        margin-top: 15px;
        width: 400px;
    }
    .selectOpt {
        position: absolute;
    }
    .dtitles {
        font-size: 12px;
        width: 400px;
    }
    .dtitle1 {
        margin-top: 25px;
    }
    .cpick2 {
        background: url('https://img.icons8.com/ios/50/000000/down-squared--v2.png') no-repeat;
        width: 50px;
        font-size: 25px;
    }
}
</style>
